#include <iostream>
#include <vector>
#include <string>

using namespace std;

int add(int a, int b, int m) {
	return ((int64_t)a + b) % m;
}

int sub(int a, int b, int m) {
	return ((int64_t)m + a - b) % m;
}

int mul(int a, int b, int m) {
	return ((int64_t)a * b) % m;
}

int val(char c) {
	return (int)(c - 'a' + 1);
}

int hash_string(string s) {
	int p = 31, M = 1000000009;
	int hash = 0;

	for(int i = 0; i < s.size(); i++)
		hash = add(mul(hash, p, M), val(s[i]), M);

	return hash;
}

void search(string s, string t) {
	int p = 31, M = 1000000009;

	int n = s.size(), m = t.size();

	int sh = hash_string(s);
	int th = hash_string(t.substr(0, n));

	int pn = 1;
	for(int i = 0; i < n; i++)
		pn = mul(pn, p, M);

	if(sh == th)
		cout << 0 << '\n';

	for(int i = n; i < m; i++) {
		th = mul(th, p, M);
		th = sub(th, mul(pn, val(t[i - n]), M), M);
		th = add(th, val(t[i]), M);

		if(sh == th)
			cout << i - n + 1 << '\n';
	}
}

int main() {

	string s, t;
	cin >> s >> t;

	search(s, t);

	return 0;
}
