#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<int> manacher(string s) {
	int n = s.size();
	vector<int> p(n, 1);

	int l = 0, d = 0;
	for(int i = 1; i < n; i++) {
		if(i <= d)
			p[i] = min(p[l + d - i], d - i + 1);
		while(i + p[i] < n && i - p[i] >= 0 && s[i + p[i]] == s[i - p[i]])
			p[i]++;
		if(i + p[i] - 1 > d) {
			l = i - p[i] + 1;
			d = i + p[i] - 1;
		}
	}

	return p;
}

int main() {
	string s;
	cin >> s;

	// Formira se string #s1#s2#...#sn#
	string t = "#";
	for(int i = 0; i < s.size(); i++) {
		t += s[i];
		t += "#";
	}

	vector<int> p = manacher(t);

	cout << t << '\n';
	for(int x : p)
		cout << x;
	cout << '\n';

	// Odredjuje maksimalni palindrom koji je podstring datog stringa
	int i = max_element(p.begin(), p.end()) - p.begin();

	// Duzina palindroma
	int d = p[i] - 1;

	// Formula za transformaciju indeksa iz prosirenog stringa u pocetni je i/2
	cout << s.substr((i - d + 1) / 2, d) << '\n';

	return 0;
}
