#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<int> manacher(string s) {
	int n = s.size();
	vector<int> p(n, 1);

	int l = 0, d = 0;
	for(int i = 1; i < n; i++) {
		if(i <= d)
			p[i] = min(p[l + d - i], d - i + 1);
		while(i + p[i] < n && i - p[i] >= 0 && s[i + p[i]] == s[i - p[i]])
			p[i]++;
		if(i + p[i] - 1 > d) {
			l = i - p[i] + 1;
			d = i + p[i] - 1;
		}
	}

	return p;
}

int main() {
	string s;
	cin >> s;

	string t = "#";
	for(int i = 0; i < s.size(); i++) {
		t += s[i];
		t += "#";
	}

	vector<int> p = manacher(t);

	cout << t << '\n';
	for(int x : p)
		cout << x;
	cout << '\n';

	int q;
	cin >> q;
	while(q--) {
		int a, b;
		cin >> a >> b;

		// Duzina podstringa
		int d = b - a + 1;

		// Prebacujemo indekse iz pocetnog stringa u prosireni
		a = 2 * a + 1;
		b = 2 * b + 1;

		// Sredina intervala [a, b]
		int s = (a + b) / 2;
		cout << s << "\n";

		// Duzina maksimalnog palindroma sa centrom u s
		int md = p[s] - 1;
		if(d <= md)
			cout << "Jeste palindrom.\n";
		else
			cout << "Nije palindrom.\n";
	}

	return 0;
}
